'-----------------------------------------------------------------------------
'           Font load routine ver.2.0 (c) 2000 by CFM-SOFTWARE
'-----------------------------------------------------------------------------
'
' This rountine makes it posible to load and use a font, which is made in
' Font editor. There are 2 subroutines in this file:
'
' SUB loadfont(file$) ' load a font in memory
'       - file$      -> name of the font-file
'
' SUB showfont (text$, x%, y%, marg%, fact%) ' show font
'       - text$      -> text, which should be printed
'       - x%         -> x-coordinate in pixels
'       - y%         -> y-coordinate in pixels
'       - marg%      -> marge between to letters(in pixels)
'       - fact%      -> enlarges the text, 1 = normal (8x16)
'       - degr%      -> makes it posible to turn your font
'                       0 - normal
'                       1 - the top of font is turned to the left
'                       2 - the top of font is turned to the right
'                       3 - turns the font upside down
'
' fontname$ -> gives the name of the font
'
' This routine is produced by Coen Martinus in the year 2000. It is based on
' an older routine of mine, which I produced between 1997/1998. This routine
' makes it posible in Q(uick)-Basic to write a text over the background in a
' grafical screen, without removing the background pixels. It is also posible
' to create your own characters.
'
' This routine is free, and your allowed to use this routine in your own
' programs as long as you keep the copyright of this program by the author of
' this routine: Coen Martinus  (The Netherlands, 'European Union')
' E-mail: cfm_mart@hotmail.com
'
' USE ON YOUR OWN RISK / NUTZUNG AUF EIGEN RISIKO / GEBRUIK OP EIGEN RISICO
'
DECLARE SUB loadfont (file$)
DECLARE SUB showfont (text$, x%, y%, marg%, fact%, degr%)
DIM SHARED let$(256), fontname$
'
SCREEN 12
PAINT (100, 100), 5
COLOR 14
CALL loadfont("system.pfn")
CALL showfont("  THIS IS THE FONT-LOADER DEMO", 1, 10, 4, 2, 0)
CALL showfont("+", 255, 160, 0, 20, 0)
'
COLOR 10
CALL showfont("UP", 312, 200, 1, 2, 0)
CALL showfont("DOWN", 288, 350, 1, 2, 3)
CALL showfont("LEFT", 262, 234, 1, 2, 2)
CALL showfont("RIGHT", 262, 434, 1, 2, 1)
'
COLOR 15
CALL showfont("You can write your letters big or you can change de distance between", 1, 58, 1, 1, 0)
CALL showfont("THE LETTERS", 1, 74, 5, 1, 0)
CALL showfont("Turn your letters", 250, 60, 1, 1, 1)
CALL showfont("Turn your letters", 250, 580, 1, 1, 2)
'
COLOR 11
CALL showfont("You can use special characters: EXAMPLE the computer costs   1000.--", 1, 106, 1, 1, 0)
COLOR 14
CALL loadfont("euro.pfn")
CALL showfont(CHR$(2), 535, 105, 1, 1, 0)
'
COLOR 15
CALL loadfont("test.pfn")
CALL showfont("  Or you can create your own fonts with Font-editor ver.1.0", 1, 138, 2, 1, 0)

SUB loadfont (file$)

OPEN file$ FOR BINARY AS #1
        fontname$ = SPACE$(9)
        GET #1, 1, fontname$
        r = 0
        DO
                let$(r) = SPACE$(8 * 16)
                GET #1, 10 + 16 * 8 * r, let$(r)
                r = r + 1
        LOOP UNTIL r > (LOF(1) - 10) / 128 OR r = 256
CLOSE #1

END SUB

SUB showfont (text$, x%, y%, marg%, fact%, degr%) ' show font
IF degr% = 2 OR degr% = 3 THEN
        x% = -1 * x%
END IF
oldy = y%
FOR r = 1 TO LEN(text$)
        acode = ASC(MID$(text$, r, 1))
        kol = 0
        row = 1
        FOR q = 1 TO 128
                kol = kol + 1
                IF kol = 9 THEN
                        kol = 1
                        row = row + 1
                ELSE
                END IF
        GOSUB fontonscreen
        NEXT q
x% = x% + 8 * fact% + marg%
NEXT r
EXIT SUB

fontonscreen:
a = VAL(MID$(let$(acode), q, 1))
IF a = 1 THEN
        IF fact% = 1 THEN
                SELECT CASE degr%
                CASE IS = 1
                        d = y% - row
                        e = x% + kol
                CASE IS = 2
                        d = y% + row
                        e = LEN(text$) * (8 + marg%) - x% - kol
                CASE IS = 3
                        d = LEN(text$) * (8 + marg%) - x% - kol
                        e = 16 + y% - row
                CASE ELSE
                        d = x% + kol
                        e = y% + row
                END SELECT
       
                PSET (d, e)
        ELSE
                SELECT CASE degr%
                        CASE IS = 1
                        d = y% - row * fact% + fact%
                        e = x% + kol * fact% - fact%
                        f = y% - row * fact%
                        g = x% + kol * fact%
                CASE IS = 2
                        d = y% + row * fact% - fact%
                        e = LEN(text$) * (8 + marg%) * fact% - (x% + kol * fact% - fact%)
                        f = y% + row * fact%
                        g = LEN(text$) * (8 + marg%) * fact% - (x% + kol * fact%)
                CASE IS = 3
                        d = LEN(text$) * (8 + marg%) * fact% - (x% + kol * fact% - fact%)
                        e = 16 * fact% + y% - row * fact% - fact%
                        f = LEN(text$) * (8 + marg%) * fact% - (x% + kol * fact%)
                        g = 16 * fact% + y% - row * fact%
                CASE ELSE
                        d = x% + kol * fact% - fact%
                        e = y% + row * fact% - fact%
                        f = x% + kol * fact%
                        g = y% + row * fact%
        END SELECT
               
               
               
                LINE (d, e)-(f, g), , BF
        END IF
ELSE
END IF

RETURN





END SUB

